var mytoken="";

import $md5 from './md5.js';
let APP_KEY = 'yunTu';
let APP_SECRET = '%smFANedN7M%B&Ig';
//import $request from '@/myExpand/jsTools/request.js';
var $request = require('@/myExpand/jsTools/request.js');
var bctaobao = require("@/static/js/bcAuth.js");
//this.init();
module.exports = {
	
	apiUrl:'https://bb.sqwolf.com/api/v1.',
	
	init:function(){
		mytoken = uni.getStorageSync('token');
	},
	
	//获取配置项
	getConfig(arr){
		let _self = this;
		return new Promise(function (resolve, reject) {
			console.log(_self.apiUrl);
			uni.request({
				url: _self.apiUrl + 'config/getConfigs',
				data: {
					names: arr
				},
				method: 'POST',
				success: function(res) {
					console.log(res);
					resolve(res.data);
				}
			})
		});
	},
	
	
	
	
	
	
	copyInfo:function(info,tipMsg){
		
		let a = info.replace(/&lt;/g,'<').replace(/&gt;/g,'>')
		
		let b = a.replace(/<br>/g,'\n')
		
		//console.log(a);
		uni.setClipboardData({
			data: b,
			success() {
				uni.vibrateShort();
				if(tipMsg){
					uni.showToast({
						title:tipMsg,
						icon:'none'
					})
				}
			}
		})
	},
	
	//返回上一级或多级
	back:function(step){
		uni.navigateBack({
			delta: step?step:1
		});
	},
	//跳转到指定页面
	goToUrl:function(url,type,isLogin){
		//console.log(type+':'+url);
		let login = isLogin?isLogin:false;
		var mytoken = uni.getStorageSync('token');
		if(login && !mytoken){
			uni.navigateTo({
				url:'/pages/submit/login'
			})
		}else{
			//console.log("nononononono ");
			switch (type){
				case 'navigateTo':
					uni.navigateTo({
						url:url
					})
					break;
				case 'redirectTo':
					uni.redirectTo({
						url:url
					})
					break;
				case 'reLaunch':
					uni.reLaunch({
						url:url
					})
					break;
				case 'switchTab':
					uni.switchTab({
						url:url
					})
					break;
				default:
					uni.navigateTo({
						url:url
					})
					break;
			}
		}
		
		
		
		
	},
	
		
	goToShopDetail:function(shopid){
		uni.navigateTo({
			url:'/pages/life/shopdetail?shopid='+shopid
		})
	},
	//跳转到商品详情页
	goToGoodsDetail:function(goodsid){
		uni.navigateTo({
			url:'/pages/detail/detail?goodsid='+goodsid
		})
		/* try{
			let value=uni.getStorageSync('token');
			if(value){
				uni.navigateTo({
					url:'/pages/detail/detail?goodsid='+goodsid
				})
			}else{
				uni.navigateTo({
					url:'/pages/submit/login'
				})
			}
		}catch(e){
			uni.navigateTo({
				url:'/pages/submit/login'
			})
		} */

	},
	goToGoodsDetailItem:function(item){
		let deItem = encodeURIComponent(JSON.stringify(item));
		uni.navigateTo({
			url:'/pages/detail/detail?goodsinfo='+deItem
		})
	},
	
	//去京东 商品详情
	goToJdGoodsDetail:function(goodsid){
		uni.navigateTo({
			url:'/pages/jd/goodsDetail?goodsid='+goodsid
		})
	},
	goToJdGoodsDetailItem:function(item){
		let deItem = encodeURIComponent(JSON.stringify(item));
		//console.log(deItem);
		uni.navigateTo({
			url:'/pages/jd/goodsDetail?goodsinfo='+deItem
		})
	},
	//去拼多多 商品详情
	goToPddGoodsDetail(goodsid){
		uni.navigateTo({
			url:'/pages/pdd/goodsDetail?goodsid='+goodsid
		})
	},
	goToPddGoodsDetailItem:function(item){
		let deItem = encodeURIComponent(JSON.stringify(item));
		uni.navigateTo({
			url:'/pages/pdd/goodsDetail?goodsinfo='+ deItem
		})
	},
	//去唯品会 商品详情
	goToVipGoodsDetail(goodsid){
		uni.navigateTo({
			url:'/pages/vip/goodsDetail?goodsid='+goodsid
		})
	},
	goToVipGoodsDetailItem:function(item){
		let deItem = encodeURIComponent(JSON.stringify(item));
		uni.navigateTo({
			url:'/pages/vip/goodsDetail?goodsinfo='+ deItem
		})
	},
	
	//跳转到分享页面
	shareGoods:function(id){
		console.log(id);
		var mytoken = uni.getStorageSync('token');
		//console.log("我的uid:"+mytoken);
		if(mytoken){
			uni.navigateTo({
				url:'/pages/share/share2?goodsid='+id
			})
		}else{
			uni.navigateTo({
				url:'/pages/submit/login'
			})
		}
		
		
	},
	
	//轮播图banner跳转
	async menuTap(e){
		console.log(e);
		
		if(!e.link){
			return false;
		}
		let a = e.link.split("#");
		//console.log(a)
		if(a.indexOf('login')>0){
			console.log("去判断是否登录");
			await this.isloginSync();
		}
		if(a.indexOf('auth')>0){
			console.log("去判断是否授权");
			await this.isAuthSync(true);
		}
		
		uni.navigateTo({
			url:a[0]
		})
		
	},
	
	
	//轮播图banner跳转
	async bannerInfo(e){
		console.log(e);
		switch (e.url_type){
			case 1:
				//淘宝商品
				this.goToGoodsDetail(e.data);
				console.log(e.data);
				break;
			case 2:
				//本地生活商户
				this.goToShopDetail(e.data);
				
				break;
			case 3:
				//京东商品
				this.goToJdGoodsDetail(e.data);
				break;
			case 4:
				//拼多多商品
				this.goToPddGoodsDetail(e.data);
				break;
			case 5:
				//唯品会 商品
				this.goToVipGoodsDetail(e.data);
				break;
			default:
				if(!e.data){
					return false;
				}
				let a = e.data.split("#");
				//console.log(a)
				if(a.indexOf('login')>0){
					console.log("去判断是否登录");
					await this.isloginSync();
				}
				if(a.indexOf('auth')>0){
					console.log("去判断是否授权");
					await this.isAuthSync(true);
				}
				
				uni.navigateTo({
					url:a[0]
				})
				break;
		}
		
	},
	//获取是否登录
	isloginSync(){
		return new Promise(function (resolve, reject) {
			try{
				let value=uni.getStorageSync('token');
				if(value){
					console.log('已登录');
					resolve(value);
				}else{
					uni.navigateTo({
						url:'/pages/submit/login'
					})
				}
			}catch(e){
				uni.navigateTo({
					url:'/pages/submit/login'
				})
			}
		})
		
	},
	//判断用户是否授权
	isAuthSync(e){
		return new Promise((resolve, reject) => {
			let isGoAuth = e ? true : false;
			console.log(isGoAuth);
			let mytoken = uni.getStorageSync('token');
			uni.request({
				url:this.apiUrl+'personal_center/baseInfo',
				header:{token:mytoken},
				success:function(res){
					console.log(res);
					if(res.data.code==200){
						//bctaobao
						if(isGoAuth){
							if(res.data.data.isTb=='已授权'){
								resolve('已授权');
							}else{
								bctaobao.baichuanoa('0');
							}
						}else{
							resolve(res.data);
						}
						
					}else if(res.data.code == 401){
						uni.navigateTo({
							url:'/pages/submit/login'
						})
					}else{
						uni.showToast({
							title:res.data.msg,
							icon:'none'
						})
					}
					
				}
			});
			
			
		});
		
	},
	
	
	
	/*当前版本号
	* 
	*/
	appVersion: function(){
		let _self = this;
		return new Promise(function (resolve, reject) {
			plus.runtime.getProperty(plus.runtime.appid, function(inf) {
				resolve(inf.version)
			})
		})
		
	},

	/* 判断用户是否登录 */
	isLogin(loginUrl,toType){
		try{
			let value=uni.getStorageSync('token');
			if(value){
				return value;
			}else{
				if(loginUrl){
					this.goToUrl(loginUrl,toType);
				}
				return false;
			}
		}catch(e){
			if(loginUrl){
				this.goToUrl(loginUrl,toType);
			}
			return false;
		}
	},
	logout(delta,page){
		console.log(delta);
		let a = delta?delta:1;
		try {
		    uni.removeStorageSync('token');
			if(page){
				uni.switchTab({
					url:'/pages/user/index'
				})
			}else{
				uni.navigateTo({
					url:'/pages/submit/login?back='+a
				})
			}
			
		} catch (e) {
		    // error
		}
	},
	
	
	//tokenUpload
	
	tokenUploadFileOne(url,path,data,callback,islogin){
		let gologin = islogin?islogin:'yes';
		//console.log(gologin);
		try{
			var header = uni.getStorageSync('token');
			//console.log(header);
			if(gologin=='yes'){
				//如果header不通过，需要跳转登录
				
				if(header){
					
					uni.uploadFile({
						url: url, //仅为示例，非真实的接口地址
						filePath: path,
						name: 'file',
						formData: data,
						header   : {token:header},
						success: (uploadFileRes) => {
							//console.log(JSON.parse(uploadFileRes.data));
							callback(JSON.parse(uploadFileRes.data));
						},
						fail     : () => {uni.showToast({title:"网络请求失败", icon:"none"});}
					});
					
				}else{
					uni.hideLoading();
					uni.navigateTo({
						url:'/pages/submit/login?back=1'
					})
					return;
				}
				
				
			}else{
				uni.uploadFile({
					url: url, //仅为示例，非真实的接口地址
					filePath: path,
					name: 'file',
					formData: data,
					success: (uploadFileRes) => {
						callback(uploadFileRes.data);
					},
					fail     : () => {uni.showToast({title:"网络请求失败", icon:"none"});}
				});
			
			}
			
			
			
		
		
		
		}catch(e){
			console.log(e);
			//TODO handle the exception
			/* uni.showToast({
				title:JSON.stringify(islogin),
				icon:'none'
			}) */
		}
		
		
		
		
		
	},

	
	tokenUploadFileMany(url,files,data,callback,islogin){
		let gologin = islogin?islogin:'yes';
		console.log(gologin);
		try{
			var header = uni.getStorageSync('token');
			//console.log(header);
			if(gologin=='yes'){
				//如果header不通过，需要跳转登录
				
				if(header){
					
					uni.uploadFile({
						url: url, //仅为示例，非真实的接口地址
						files:files,
						formData: data,
						header   : {token:header},
						success: (uploadFileRes) => {
							console.log(uploadFileRes);
							callback(JSON.parse(uploadFileRes.data));
						},
						fail     : () => {uni.showToast({title:"网络请求失败", icon:"none"});}
					});
					
				}else{
					uni.hideLoading();
					uni.navigateTo({
						url:'/pages/submit/login?back=1'
					})
					return;
				}
				
				
			}else{
				uni.uploadFile({
					url: url, //仅为示例，非真实的接口地址
					files:files,
					formData: data,
					success: (uploadFileRes) => {
						callback(uploadFileRes.data);
					},
					fail     : () => {uni.showToast({title:"网络请求失败", icon:"none"});}
				});
			
			}
			
			
			
		
		
		
		}catch(e){
			console.log(e);
			//TODO handle the exception
			/* uni.showToast({
				title:JSON.stringify(islogin),
				icon:'none'
			}) */
		}
		
		
		
		
		
	},
	
	drawJdShareImg(goodsBaseInfo,callback,id){
		console.log(goodsBaseInfo);
		let canvasId = id?id:'sharePoster';
		var context = uni.createCanvasContext(canvasId);
		console.log(context);
		context.rect(0, 0, 750, 1100)
		context.setFillStyle('#fff')
		context.fill();
		context.setFontSize(28);
		context.setTextAlign('left');
		
		
		//绘制商品主体图片
		console.log(goodsBaseInfo.imageInfo.imageList[0].url);
		context.drawImage(goodsBaseInfo.imageInfo.imageList[0].url, 30, 30, 690, 690);
		
		//价格
		context.fillStyle = "#F64E66";
		context.fillText("券后价￥", 30, 980);
		//context.setFontSize(36);
		context.font = "bold 36px Arial";
		context.fillText(parseFloat(goodsBaseInfo.priceInfo.lowestCouponPrice?goodsBaseInfo.priceInfo.lowestCouponPrice:goodsBaseInfo.priceInfo.lowestPrice), 140, 980);
	
		//商品标题
		context.fillStyle = "#666";
		context.font = "normal 22px Arial";
		
		var str = goodsBaseInfo.skuName;
		var tuijianTxtLineNum = 17;
		var lineHeight = 30;
		var initHeight = 840;
		var tuijianWidth = 430; //今日推荐文本canvas的宽度
		context.fillStyle = "#F64E66";
		context.font = "normal 28px Arial";
		context.fillText("【京东商品】", 30, initHeight-40);
		
		
		if (str.length > tuijianTxtLineNum) {
			var lineNum=Math.ceil(str.length/tuijianTxtLineNum);
			//console.log(str.length/tuijianTxtLineNum);
			for (let i = 0; i < lineNum; i++) {
				var result = str.substring(i*tuijianTxtLineNum,(i+1)*tuijianTxtLineNum);
				context.fillStyle = "#666";
				context.font = "normal 24px Arial";
				context.fillText(result, 30, initHeight);
				initHeight += 30; //20为字体的高度
				
			}
			
		}else{
			context.fillText(str, 30, initHeight);
		}
		
		// 绘制二维码
		console.log(goodsBaseInfo.qrcode)
		context.drawImage(goodsBaseInfo.qrcode, 480, 780, 200, 200);
		context.fillStyle = "#666";
		context.font = "normal 26px Arial";
		context.fillText("长按识别二维码领优惠", 450, 1010);
		
		if(goodsBaseInfo.couponInfo.couponList[0])	{
			// 绘制券
			let selfTxtY = 950;
			let baseTxtX = 300;
			let selfTxtX = 400;
			context.drawImage("/static/img/share/quan_bg.png", baseTxtX+5, selfTxtY, 103, 36);
			context.fillStyle = "#fff";
			context.font = "normal 20px Arial";
			switch (true) {
				case goodsBaseInfo.couponInfo.couponList[0].discount > 999:
					console.log("四位数券");
					selfTxtX = baseTxtX+15;
					break;
				case goodsBaseInfo.couponInfo.couponList[0].discount > 99:
					console.log("三位数券");
					selfTxtX = baseTxtX+20;
					break;
				case goodsBaseInfo.couponInfo.couponList[0].discount > 9:
					console.log("两位数券");
					selfTxtX = baseTxtX+25;
					break;
				default:
					console.log("一位数券");
					selfTxtX = baseTxtX+30;
					break;
			}
				
			context.fillText(goodsBaseInfo.couponInfo.couponList[0].discount + "元券", selfTxtX, selfTxtY+25);
			context.setTextAlign('center');
		}
		
	
		console.log("222");
		context.stroke();
			
		context.draw(false, () => {
			
			
			uni.canvasToTempFilePath({
				x: 0,
				y: 0,
				width: 750,
				height: 1100,
				destWidth: 750,
				destHeight: 1100,
				canvasId: canvasId,
				success: function(res) {
					/* console.log(res);
					uni.hideLoading()
					_self.generateImg = res.tempFilePath;
					console.log(_self.generateImg); */
					//_self.saveToPhotosAlbum();
					callback(res);
				}
			})
			
			
			
			
			
			
		})
	},
	
	
	drawPddShareImg(goodsBaseInfo,callback,id){
		let canvasId = id?id:'sharePoster';
		var context = uni.createCanvasContext(canvasId);
		console.log(context);
		context.rect(0, 0, 750, 1100)
		context.setFillStyle('#fff')
		context.fill();
		context.setFontSize(28);
		context.setTextAlign('left');
		
		
		//绘制商品主体图片
		context.drawImage(goodsBaseInfo.goods_image_url, 30, 30, 690, 690);
		
		//价格
		context.fillStyle = "#F64E66";
		context.fillText("券后价￥", 30, 980);
		//context.setFontSize(36);
		context.font = "bold 36px Arial";
		context.fillText(parseFloat(goodsBaseInfo.goods_end_price), 140, 980);
	
		//商品标题
		context.fillStyle = "#666";
		context.font = "normal 22px Arial";
		
		var str = goodsBaseInfo.goods_name;
		var tuijianTxtLineNum = 17;
		var lineHeight = 30;
		var initHeight = 840;
		var tuijianWidth = 430; //今日推荐文本canvas的宽度
		context.fillStyle = "#F64E66";
		context.font = "normal 28px Arial";
		context.fillText("【拼多多商品】", 30, initHeight-40);
		
		
		if (str.length > tuijianTxtLineNum) {
			var lineNum=Math.ceil(str.length/tuijianTxtLineNum);
			//console.log(str.length/tuijianTxtLineNum);
			for (let i = 0; i < lineNum; i++) {
				var result = str.substring(i*tuijianTxtLineNum,(i+1)*tuijianTxtLineNum);
				context.fillStyle = "#666";
				context.font = "normal 24px Arial";
				context.fillText(result, 30, initHeight);
				initHeight += 30; //20为字体的高度
				
			}
			
		}else{
			context.fillText(str, 30, initHeight);
		}
		
		// 绘制二维码
		context.drawImage(goodsBaseInfo.qrcode, 480, 780, 200, 200);
		context.fillStyle = "#666";
		context.font = "normal 26px Arial";
		context.fillText("长按识别二维码领优惠", 450, 1010);
		
		if(goodsBaseInfo.coupon_discount>0)	{
			// 绘制券
			let selfTxtY = 950;
			let baseTxtX = 300;
			let selfTxtX = 400;
			context.drawImage("/static/img/share/quan_bg.png", baseTxtX+5, selfTxtY, 103, 36);
			context.fillStyle = "#fff";
			context.font = "normal 20px Arial";
			switch (true) {
				case goodsBaseInfo.coupon_discount > 999:
					console.log("四位数券");
					selfTxtX = baseTxtX+15;
					break;
				case goodsBaseInfo.coupon_discount > 99:
					console.log("三位数券");
					selfTxtX = baseTxtX+20;
					break;
				case goodsBaseInfo.coupon_discount > 9:
					console.log("两位数券");
					selfTxtX = baseTxtX+25;
					break;
				default:
					console.log("一位数券");
					selfTxtX = baseTxtX+30;
					break;
			}
				
			context.fillText(goodsBaseInfo.coupon_discount + "元券", selfTxtX, selfTxtY+25);
			context.setTextAlign('center');
		}
		
	
		console.log("222");
		context.stroke();
			
		context.draw(false, () => {
			
			
			uni.canvasToTempFilePath({
				x: 0,
				y: 0,
				width: 750,
				height: 1100,
				destWidth: 750,
				destHeight: 1100,
				canvasId: canvasId,
				success: function(res) {
					callback(res);
				}
			})
			
			
			
			
			
			
		})
	},
	
	
	drawVipShareImg(goodsBaseInfo,callback,id){
		let canvasId = id?id:'sharePoster';
		var context = uni.createCanvasContext(canvasId);
		console.log(context);
		context.rect(0, 0, 750, 1100)
		context.setFillStyle('#fff')
		context.fill();
		context.setFontSize(28);
		context.setTextAlign('left');
		
		
		//绘制商品主体图片
		context.drawImage(goodsBaseInfo.item_pic, 30, 30, 690, 690);
		
		//价格
		context.fillStyle = "#F64E66";
		context.fillText("折后价￥", 30, 950);
		//context.setFontSize(36);
		context.font = "bold 36px Arial";
		context.fillText(parseFloat(goodsBaseInfo.item_end_price), 140, 950);
	
		//商品标题
		context.fillStyle = "#666";
		context.font = "normal 22px Arial";
		
		var str = goodsBaseInfo.item_short_title;
		var tuijianTxtLineNum = 17;
		var lineHeight = 30;
		var initHeight = 840;
		var tuijianWidth = 430; //今日推荐文本canvas的宽度
		context.fillStyle = "#F64E66";
		context.font = "normal 28px Arial";
		context.fillText("【唯品会商品】", 30, initHeight-40);
		
		
		if (str.length > tuijianTxtLineNum) {
			var lineNum=Math.ceil(str.length/tuijianTxtLineNum);
			//console.log(str.length/tuijianTxtLineNum);
			for (let i = 0; i < lineNum; i++) {
				var result = str.substring(i*tuijianTxtLineNum,(i+1)*tuijianTxtLineNum);
				context.fillStyle = "#666";
				context.font = "normal 24px Arial";
				context.fillText(result, 30, initHeight);
				initHeight += 30; //20为字体的高度
				
			}
			
		}else{
			context.fillText(str, 30, initHeight);
		}
		
		// 绘制二维码
		context.drawImage(goodsBaseInfo.qrcode, 480, 780, 200, 200);
		context.fillStyle = "#666";
		context.font = "normal 26px Arial";
		context.fillText("长按识别二维码领优惠", 450, 1010);
		
		if(goodsBaseInfo.discount_desc)	{
			// 绘制券
			let selfTxtY = 950;
			let baseTxtX = 300;
			let selfTxtX = 30;
			context.fillStyle = "#F64E66";
			context.fillText(goodsBaseInfo.discount_desc, selfTxtX, selfTxtY+35);
			context.setTextAlign('center');
		}
		
	
		console.log("222");
		context.stroke();
			
		context.draw(false, () => {
			
			
			uni.canvasToTempFilePath({
				x: 0,
				y: 0,
				width: 750,
				height: 1100,
				destWidth: 750,
				destHeight: 1100,
				canvasId: canvasId,
				success: function(res) {
					callback(res);
				}
			})
			
			
			
			
			
			
		})
	},
	
	
	
	drawImg(goodsBaseInfo,callback,id) {
		
		//console.log(goodsBaseInfo);
		let canvasId = id?id:'sharePoster';
		var context = uni.createCanvasContext(canvasId);
		//context.clearRect(0, 0, 750, 1334);
		console.log(context);
		context.rect(0, 0, 750, 1334)
		context.setFillStyle('#fff')
		context.fill();
		context.setFontSize(28);
		context.setTextAlign('left');
		//标题
		context.fillStyle = "#333";
		context.fillText(goodsBaseInfo.itemshorttitle, 60, 60);
		console.log(goodsBaseInfo.shoptype);
		let thisShopImg=goodsBaseInfo.shoptype=='B'?'/static/img/icon/tmall.png':'/static/img/icon/taobao.png'
		context.drawImage(thisShopImg, 30, 32, 30, 30);
		//价格
		context.fillStyle = "#F64E66";
		context.fillText("券后价￥", 30, 160);
		//context.setFontSize(36);
		context.font = "bold 36px Arial";
		context.fillText(parseFloat(goodsBaseInfo.itemendprice), 140, 160);
	
		//s原价
		context.fillStyle = "#999";
		context.font = "normal 24px Arial";
		context.fillText("原价:￥" + parseFloat(goodsBaseInfo.itemprice), 230, 160);
		
		//今日推荐
		context.fillStyle = "#666";
		context.font = "normal 22px Arial";
		
		var str = goodsBaseInfo.itemdesc?goodsBaseInfo.itemdesc:goodsBaseInfo.copy_content;
		var tuijianTxtLineNum = 17;
		var lineHeight = 30;
		var initHeight = 980;
		var tuijianWidth = 430; //今日推荐文本canvas的宽度
		context.fillStyle = "#F64E66";
		context.font = "normal 24px Arial";
		context.fillText("【今日推荐】", 30, initHeight-40);
		
		
		if (str.length > tuijianTxtLineNum) {
			var lineNum=Math.ceil(str.length/tuijianTxtLineNum);
			//console.log(str.length/tuijianTxtLineNum);
			for (let i = 0; i < lineNum; i++) {
				var result = str.substring(i*tuijianTxtLineNum,(i+1)*tuijianTxtLineNum);
				context.fillStyle = "#666";
				context.font = "normal 24px Arial";
				context.fillText(result, 30, initHeight);
				initHeight += 30; //20为字体的高度
				
			}
			
		}else{
			context.fillText(str, 30, initHeight);
		}
		
		// 绘制二维码
		context.drawImage(goodsBaseInfo.qrcode, 480, 920, 200, 200);
		context.fillStyle = "#666";
		context.font = "normal 26px Arial";
		context.fillText("长按识别二维码领优惠", 450, 1150);
	
		// 绘制券
		context.drawImage("/static/img/share/quan_bg.png", 615, 120, 103, 36);
		context.fillStyle = "#fff";
		context.font = "normal 20px Arial";
	
		let selfTxtX = 610;
	
		switch (true) {
			case goodsBaseInfo.couponmoney > 999:
				console.log("四位数券");
				selfTxtX = 625;
				break;
			case goodsBaseInfo.couponmoney > 99:
				console.log("三位数券");
				selfTxtX = 630;
				break;
			case goodsBaseInfo.couponmoney > 9:
				console.log("两位数券");
				selfTxtX = 635;
				break;
			default:
				console.log("一位数券");
				selfTxtX = 640;
				break;
		}
	
		context.fillText(goodsBaseInfo.couponmoney + "元券", selfTxtX, 145);
		context.setTextAlign('center');
		
		//绘制商品主体图片
		console.log(goodsBaseInfo.itempic);
		let mainPic = goodsBaseInfo.itempic?goodsBaseInfo.itempic:goodsBaseInfo.taobao_image[0];
		context.drawImage(mainPic, 30, 200, 690, 690);
		//绘制推荐，和二维码
		
		//底部提示
		//console.log(goodsBaseInfo.qrcode);
		context.drawImage('/static/img/share/poster_foot.png', 30, 1220, 690, 80);
		console.log("222");
		context.stroke();
	
		context.draw(false, () => {
			
			
			uni.canvasToTempFilePath({
				x: 0,
				y: 0,
				width: 750,
				height: 1334,
				destWidth: 750,
				destHeight: 1334,
				canvasId: canvasId,
				success: function(res) {
					/* console.log(res);
					uni.hideLoading()
					_self.generateImg = res.tempFilePath;
					console.log(_self.generateImg); */
					//_self.saveToPhotosAlbum();
					callback(res);
				}
			})
			
			
			
			
			
			
		})
	},
	drawImg2(goodsBaseInfo,callback,id) {
		
		//console.log(goodsBaseInfo);
		let canvasId = id?id:'sharePoster';
		var context = uni.createCanvasContext(canvasId);
		//context.clearRect(0, 0, 750, 1334);
		console.log(context);
		context.rect(0, 0, 750, 1334)
		context.setFillStyle('#fff')
		context.fill();
		context.setFontSize(28);
		context.setTextAlign('left');
		//标题
		context.fillStyle = "#333";
		context.fillText(goodsBaseInfo.item_short_title, 60, 60);
		console.log(goodsBaseInfo.platform);
		let thisShopImg=goodsBaseInfo.platform=='TM'?'/static/img/icon/tmall.png':'/static/img/icon/taobao.png'
		context.drawImage(thisShopImg, 30, 32, 30, 30);
		//价格
		context.fillStyle = "#F64E66";
		context.fillText("券后价￥", 30, 160);
		//context.setFontSize(36);
		context.font = "bold 36px Arial";
		context.fillText(parseFloat(goodsBaseInfo.item_end_price), 140, 160);
	
		//s原价
		context.fillStyle = "#999";
		context.font = "normal 24px Arial";
		context.fillText("原价:￥" + parseFloat(goodsBaseInfo.item_price), 230, 160);
		
		//今日推荐
		context.fillStyle = "#666";
		context.font = "normal 22px Arial";
		
		var str = goodsBaseInfo.item_desc||goodsBaseInfo.guide_article;
		var tuijianTxtLineNum = 17;
		var lineHeight = 30;
		var initHeight = 980;
		var tuijianWidth = 430; //今日推荐文本canvas的宽度
		context.fillStyle = "#F64E66";
		context.font = "normal 24px Arial";
		context.fillText("【今日推荐】", 30, initHeight-40);
		
		
		if (str.length > tuijianTxtLineNum) {
			var lineNum=Math.ceil(str.length/tuijianTxtLineNum);
			//console.log(str.length/tuijianTxtLineNum);
			for (let i = 0; i < lineNum; i++) {
				var result = str.substring(i*tuijianTxtLineNum,(i+1)*tuijianTxtLineNum);
				context.fillStyle = "#666";
				context.font = "normal 24px Arial";
				context.fillText(result, 30, initHeight);
				initHeight += 30; //20为字体的高度
				
			}
			
		}else{
			context.fillText(str, 30, initHeight);
		}
		
		// 绘制二维码
		console.log(goodsBaseInfo.qrcode);
		context.drawImage(goodsBaseInfo.qrcode, 480, 920, 200, 200);
		context.fillStyle = "#666";
		context.font = "normal 26px Arial";
		context.fillText("长按识别二维码领优惠", 450, 1150);
	
		// 绘制券
		context.drawImage("/static/img/share/quan_bg.png", 615, 120, 103, 36);
		context.fillStyle = "#fff";
		context.font = "normal 20px Arial";
	
		let selfTxtX = 610;
	
		switch (true) {
			case goodsBaseInfo.coupon_money > 999:
				console.log("四位数券");
				selfTxtX = 625;
				break;
			case goodsBaseInfo.coupon_money > 99:
				console.log("三位数券");
				selfTxtX = 630;
				break;
			case goodsBaseInfo.coupon_money > 9:
				console.log("两位数券");
				selfTxtX = 635;
				break;
			default:
				console.log("一位数券");
				selfTxtX = 640;
				break;
		}
	
		context.fillText(goodsBaseInfo.coupon_money + "元券", selfTxtX, 145);
		context.setTextAlign('center');
		
		//绘制商品主体图片
		console.log(goodsBaseInfo.item_pic);
		let mainPic = goodsBaseInfo.item_pic||goodsBaseInfo.item_img_list[0];
		context.drawImage(mainPic, 30, 200, 690, 690);
		//绘制推荐，和二维码
		
		//底部提示
		//console.log(goodsBaseInfo.qrcode);
		context.drawImage('/static/img/share/poster_foot.png', 30, 1220, 690, 80);
		console.log("222");
		context.stroke();
		console.log("333");
		context.draw(false, () => {
			
			console.log("444");
			uni.canvasToTempFilePath({
				x: 0,
				y: 0,
				width: 750,
				height: 1334,
				destWidth: 750,
				destHeight: 1334,
				canvasId: canvasId,
				success: function(res) {
					/* console.log(res);
					uni.hideLoading()
					_self.generateImg = res.tempFilePath;
					console.log(_self.generateImg); */
					//_self.saveToPhotosAlbum();
					callback(res);
				}
			})
			
			
			
			
			
			
		})
	},

	saveImg() {
		console.log("444");
		//保存图片格式
		uni.canvasToTempFilePath({
			x: 0,
			y: 0,
			width: 750,
			height: 1334,
			destWidth: 750,
			destHeight: 1334,
			canvasId: 'sharePoster',
			success: function(res) {
				console.log(res);
				uni.hideLoading()
				_self.generateImg = res.tempFilePath;
				console.log(_self.generateImg);
				//_self.saveToPhotosAlbum();
			}
		})
	},
	
	
	
	sendVcode(){
		uni.request({
			url: this.apiUrl + 'captcha/send',
			method: 'POST',
			data: captchaData,
			success(res) {
				console.log(res)
				uni.showToast({
					title: res.data.msg,
					icon: 'none'
				});
				if(res.data.code == 200){
					// 倒计时
					_self.countNum = 120;
					_self.countDownTimer = setInterval(function() {
						_self.countDown();
					}.bind(this), 1000);
				}
			},
		});
	},
	
	countDown() {
		console.log("_____________");
		if (this.countNum < 1) {
			clearInterval(_self.countDownTimer);
			this.vcodeBtnName = '重新发送';
			return;
		} else if (this.countNum < 11) {
			this.countNum--;
			this.vcodeBtnName = '0' + this.countNum + 's 重发'
			return;
		}
		this.countNum--;
		this.vcodeBtnName = this.countNum + 's 重发'
	},
	
	/**
	 * @param {Object} params
	 * 加密
	 */
	
	getSign(params) {
		/* uni.setStorage({
		    key: 'APP_KEY',
		    data: 'yunTu',
		    success: function () {
		        console.log('success');
		    }
		});
		uni.setStorage({
		    key: 'APP_SECRET',
		    data: '%smFANedN7M%B&Ig',
		    success: function () {
		        console.log('success');
		    }
		}); */
		if (typeof params == "string") {
			return this.paramsStrSort(params);
		} else if (typeof params == "object") {
			var arr = [];
			for (var i in params) {
				arr.push((i + "=" + params[i]));
			}
			return this.paramsStrSort(arr.join(("&")));
		}
	},
	paramsStrSort(paramsStr) {
		/* var app_key,app_secret
		uni.getStorage({
		    key: 'APP_KEY',
		    success: function (res) {
				app_key=res.data
		    }
		});
		uni.getStorage({
		    key: 'APP_SECRET',
		    success: function (res) {
				app_secret=res.data
		    }
		}); */
		var url = paramsStr + "&appKey=" + APP_KEY;
		var urlStr = url.split("&").sort().join("&");
		var newUrl = urlStr + '&appSecret=' + APP_SECRET;
		//console.log(newUrl);
		return $md5(newUrl);
	},
	
}

