var socketOpen = false;
var chatRoomSocket;
var tiaoTimer;
module.exports = {
	//创建socket链接
	 connect(data){
		var _self = this;
		chatRoomSocket = uni.connectSocket({
			url: data.socket_url,
			success: function(res) {
				//console.log(res);
				console.log("WebSocket连接成功");
				_self.onopen(data);
				
			},
			fail: function() {
				console.log("设备初始化失败");
			},
		})
		uni.onSocketError(function(res) {
			console.log('WebSocket连接打开失败，请检查！');
			//_self.connect(token);
			
		});
	},
	//打开链接
	onopen(data){
		var _self = this;
		//兼容 打开 secket 链接事件
		uni.onSocketOpen(function(res) {
			//console.log(res);
			console.log('WebSocket连接已打开！');
			let newJson = {type:'ping'};
			tiaoTimer = setInterval(function(){
				_self.send(JSON.stringify(newJson));
			},30000);
		});
		
		
	},
	send(json){
		/* chatRoomSocket.send(function(res) {
			console.log(res);
		}) */
		uni.sendSocketMessage({
			data: json,
			success: function() {

				console.log("数据发送成功");
			},
			fail: function() {
				console.log("数据发送失败");
			}
		});
	},
	close(){
		uni.closeSocket({
			success: function() {
				console.log("websocket关闭成功");
			},
			fail: function() {
				console.log("websocket关闭失败");
			}
		});
	},
	onclose(){
		
		uni.onSocketClose(function(res) {
			console.log("websocket已关闭");
			clearInterval(tiaoTimer);
		})
	},
	
	
}